/**
 * Classe que defineix l'estructura que ha de tenir una classe gestora
 */
package edu.uoc.tfc.exuoc.controladors;

import java.util.Iterator;

import org.hibernate.HibernateException;
import edu.uoc.tfc.exuoc.errors.BuitException;
import edu.uoc.tfc.exuoc.errors.LlistatDAOException;


/**
 *
 * @author emili
 */
public interface InterfaceGestor {


    public void openGestor();
    public void tancar();
    public GestorLogs  getLog() ;
    public void setLog(GestorLogs  log);
    

    /**
     *
     * @return Nombre total d'entitats de la classe
     * @throws HibernateException
     * @throws BuitException
     */
    public int num() throws HibernateException,BuitException;
    
    /**
     * 
     * @param condicio
     * @return Retorna el total d'entitats que compleixen amb el camp nom indicat
     * @throws HibernateException
     * @throws BuitException
     */
    
    public int num(String nomCercat) throws HibernateException,BuitException;


   

    public Iterator<?> llistat() throws LlistatDAOException,BuitException;
    public Iterator<?> llistat(int ini,int fi) throws LlistatDAOException, BuitException;
    public Iterator<?> llistat(String camp,String pernom, int ini,int fi) 
            throws LlistatDAOException,BuitException;

}
