
package edu.uoc.tfc.exuoc.controladors;

import java.util.Iterator;

import org.hibernate.HibernateException;
import edu.uoc.tfc.exuoc.errors.BuitException;
import edu.uoc.tfc.exuoc.errors.LlistatDAOException;


/**
 *  classe que defineix l'estructura de les classes d'interficies gràfiques
 * @author Emili A. Moreno
 */
public interface InterfaceInGestor {

    public void openGestor();
    public void tancar();
    /**
     *
     * @return Nombre total d'entitats de la classe
     * @throws HibernateException
     * @throws BuitException
     */
    public int num() throws HibernateException,BuitException;
    
    /**
     * 
     * @param condicio
     * @return Retorna el total d'entitats que compleixen amb el camp nom indicat
     * @throws HibernateException
     * @throws BuitException
     */
    
    public int num(String nomCercat) throws HibernateException,BuitException;


   

    public Iterator<?> llistat() throws LlistatDAOException;
    public Iterator<?> llistat(int ini,int fi) throws LlistatDAOException;
    public Iterator<?> llistat(String camp,String pernom, int ini,int fi) throws LlistatDAOException;

}
