/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.uoc.tfc.exuoc.vistes;

import edu.uoc.tfc.exuoc.config.Config;
import edu.uoc.tfc.exuoc.controladors.InterfaceGestor;
import edu.uoc.tfc.exuoc.controladors.GestorItems;
import edu.uoc.tfc.exuoc.controladors.GestorContenidors;
import edu.uoc.tfc.exuoc.controladors.AbstractInGestor;
import edu.uoc.tfc.exuoc.errors.BuitException;
import edu.uoc.tfc.exuoc.errors.LlistatDAOException;
import edu.uoc.tfc.exuoc.utils.Eines;
import edu.uoc.tfc.exuoc.utils.seguretat.InjeccioCodi;

import edu.uoc.tfc.exuoc.model.Item;
import edu.uoc.tfc.exuoc.model.Contenidor;
import edu.uoc.tfc.exuoc.controladors.GestorLogs ;

import edu.uoc.tfc.exuoc.consultes.ContenidorLlistat;
import edu.uoc.tfc.exuoc.consultes.ItemLlistat;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

import com.opensymphony.xwork2.ActionSupport;
import org.hibernate.HibernateException;

/**
 *
 * @author emoreno
 */
public class IPrincipal extends AbstractInGestor {

 
    private List<ContenidorLlistat> llistaCon = new ArrayList<ContenidorLlistat>();
    private List<ItemLlistat> llistaItem= new ArrayList<ItemLlistat>();

    private int nContenidors=0;
    private int nItems=0;
    private int pos=0;

  
    

    private int contenidorsPerPagina=Config.CONTENIDOR_PAGE;
    private int itemsPerPagina=Config.ITEM_PAGE;


    public IPrincipal(){
        }

    @Override
    public void finalize(){

        this.setContenidorsPerPagina(0);
        this.setItemsPerPagina(0);
  
        this.setLog(null);
        this.setNContenidors(0);
        this.setNItems(0);
        this.pos=0;
     
    }

    @Override
    public void prepare()   {
        //Actualitzem la data de la sessió per l'usuari i assignem a idSessio
        //la sessió que li correspon.
        super.prepare();

    }
   

 

    public int getContenidorsPerPagina() {
        return this.contenidorsPerPagina;
    }

    public void setContenidorsPerPagina(int contenidorsPerPagina) {
        this.contenidorsPerPagina = contenidorsPerPagina;
    }

    public int getItemsPerPagina() {
        return this.itemsPerPagina;
    }

    public void setItemsPerPagina(int itemsPerPagina) {
        this.itemsPerPagina = itemsPerPagina;
    }


    public int getPos() {
        return pos;
    }

    //Es filtra ja que és un valor que es pot passar com a paràmetre a l'URL
    public void setPos(int pos) {
        InjeccioCodi filtre=new InjeccioCodi();
        this.pos = Integer.parseInt(filtre.netejar(pos));
    }


    public void setNItems(int _nItems) {
        this.nItems = _nItems;
    }
    public void setNContenidors(int _nContenidors) {
        this.nContenidors = _nContenidors;
    }



     public void setLlistaCon(List<ContenidorLlistat> _llistaCon) {
        this.llistaCon = _llistaCon;
    }

     public List<ContenidorLlistat> getLlistaCon() {

   ;

        return llistaCon;
    }

     public void setLlistaItem(List<ItemLlistat> _llistaItem) {
        this.llistaItem = _llistaItem;
    }

     public List<ItemLlistat> getLlistaItem() {

       
        return llistaItem;
    }

    public int getNItems() {
       
        return nItems;
    }

    public int getNContenidors() {
      
        return this.nContenidors;
    }


  
    private List<ContenidorLlistat> omplirLlistaContenidors(int ini, int fi){

        Iterator <Contenidor> ll=null;
        List<ContenidorLlistat> llistaC = new ArrayList<ContenidorLlistat>();
        GestorContenidors gc=GestorContenidors.getInstance();

        try {
            ll=gc.llistat(ini, fi);
            while (ll.hasNext()){
                Contenidor c=(Contenidor)ll.next();
                llistaC.add(new ContenidorLlistat(c.getId(),c.getNom(),c.getDatapub(),c.getItems().size()));
            }
            ll=null;
            gc.tancar();
        }catch (HibernateException ex) {
                this.getLog().error("no s'ha pogut obtenir el nombre de contenidors",ex.getLocalizedMessage());


        }catch (LlistatDAOException ex) {
                this.getLog().error("Error: Llistat. ",ex.getLocalizedMessage() );
        }finally{
            gc.tancar();
        }
       
        return llistaC;
    }



     private List<ItemLlistat> omplirLlistaUltimsItems(){

        Iterator <Item> ll=null;
        List<ItemLlistat> llistaI = new ArrayList<ItemLlistat>();

        try {

            GestorItems gi = GestorItems.getInstance();
            ll=gi.llistaUltimsItems();
            while (ll.hasNext()){
                Item i=ll.next();
                llistaI.add(
                        new ItemLlistat(i.getId(),i.getNom(),i.getDatapub(),
                            i.getAutor(),i.getVisites(),i.getArxiu().getTipus(),
                            i.getContenidor().getNom(),i.getPrivat()) );
            }
            gi.tancar();
        }catch (HibernateException ex) {
                this.getLog().error("no s'ha pogut obtenir el nombre de contenidors."
                        +ex.getLocalizedMessage());

        }catch (LlistatDAOException ex) {
                this.getLog().error("llista buida d`Ítems ");
            }
        ll=null;
        return llistaI;
    }

 
 /**
 *
 * @return nombre d'elements Items o Contenidors (Classe)
 */
    public int quants(Class classe){
        int num=Config.valorNullInt;
        String classeNom=classe.getSimpleName();
        InterfaceGestor gestor =null;

      try {

            if ( classeNom.equals(Contenidor.class.getSimpleName())){
                gestor=GestorContenidors.getInstance();
               
            }else if (classeNom.equals(Item.class.getSimpleName())){
                gestor = GestorItems.getInstance();
                //num = gestor.numItems();
                //gestor.tancar();
            }else return Config.valorNullInt;

            num = gestor.num();

          
            if (gestor!=null) gestor.tancar();
       
                
        } catch (HibernateException ex) {
            String[] llista ={classe.getSimpleName(),ex.getLocalizedMessage()};
            this.getLog().error("no s'ha pogut obtenir el nombre d'elements ,Classe :{}. {}",llista);
           
        }catch(BuitException ex){
            String[] llista ={classe.getSimpleName(),ex.getLocalizedMessage()};
            this.getLog().error("llista buida. Classe :{}. {}",llista);
           
        }catch(NullPointerException ex){
           
            this.getLog().error("s'ha indicat un valor null. {}",ex.getLocalizedMessage());
        }
        return num;

    }

   
    // Procediment per defecte del "namespace" Arrel del web
    @Override
    public String execute() {
        
        
     

        try {
            this.setNContenidors(this.quants(Contenidor.class));
            this.setNItems(this.quants(Item.class));

            if (!comprovarLimits(this.getPos(),0,this.getNContenidors())) {
                this.addActionError("Límits de posició fora de rang");
                return ActionSupport.ERROR;
            }

           
                this.setLlistaCon(
                        this.omplirLlistaContenidors( this.getPos(),
                            this.getPos()+this.getContenidorsPerPagina()));

           
                this.setLlistaItem(
                        this.omplirLlistaUltimsItems());
        }catch(NullPointerException e){
            this.getLog().error("Error obtenint la llista de dades necessàries. {}",e.getLocalizedMessage());
        }
      

        return ActionSupport.SUCCESS;
    }

 
 /**
  *
  * MAIN
  */
    public static void main(String[] args){
        //TODO : proves
        IPrincipal ip=new IPrincipal();
        ip.execute();
        Eines.escriu("nombre d`ítems: "+ip.getNItems());
        Eines.escriu("nombre de Contenidors: "+ip.getNContenidors());
        Iterator<ContenidorLlistat> i=ip.getLlistaCon().iterator();
        while (i.hasNext()){
            ContenidorLlistat lc=i.next();
            Eines.escriu(lc.getNom());
        }

//        Eines.escriu("nombre de contenidors: "+ip.getNContenidors());
//        Eines.escriu("nombre d`ítems: "+ip.quants(Item.class));
//        Eines.escriu("nombre de contenidors: "+ip.quants(Contenidor.class));

        //Eines.escriu(ip.llistaUltimsItems.iterator().next().getNom());
        //Eines.escriu(ip.llistaContenidors.iterator().next().getNom());

       
        
    }
}
